/*  Promile Qt - calculates amount of alcohol in your body
  *  Copyright (C) 2008  Marcin Dombrowski
  *
  *  This program is free software: you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation, either version 3 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>
#include "promile-qt.h"
#include "ui_promile-qt.h"
#include <string.h>
#define ILOSC_NAPOJOW 100

using namespace Ui;

extern Form ui;

class napoj; // deklaracja klasy
float wspolczynnik, waga, ilosc_plynow=0,masa=0,ostatni=0,pierwszy=0, cz=0,ile_na_godz;
napoj * napoje[ILOSC_NAPOJOW];
int co_ile;
int nr_napoju = 0;
char odp,zaawansowane='n';
const float gestosc = 0.79;
int wyswietlono ; //ktory dzien wyswietlono juz

class napoj
{
	public:
		int ilosc;              //objętość napoju [ml]
		int dlugosc_picia;      //czas spożywania teo napoju [minut]
		float stezenie;         //zawartość alkoholu [% v/v]
		float godzina;          //godzina rozpoczęcia picia
		float czas_wchlaniania; //czas po którym alkohol dostaje się do krwi
		float ile_wypite;       //ile ml wypite w danym czasie
		char spr;		//czy wypite całe
		napoj (int,float,float,float,int);
		~napoj();
};

napoj::napoj (int il, float st, float godz, float cz_wchl, int dl_pic)
{
	ilosc=il;
	stezenie=st;
	godzina=godz;
	czas_wchlaniania=cz_wchl;
	ile_wypite=0;
	dlugosc_picia=dl_pic;
	spr='n';
}

napoj::~napoj ()
{
nr_napoju=nr_napoju-1;
ostatni=0;
pierwszy=0;
}

float spytaj_o_plec(char plec)
{


	switch (plec)
	{
		case 'k' :
			return 0.6;
			break;

		case 'm' :
			return 0.7;
			break;

		default :
			return 0.7;
			break;
	}
}

float Form1::m_alk()
{	
	int nap; // numer napoju
	char koniec='n';
	float porcja=0,dawka;
	
	cz=pierwszy;
	masa=0;
	while ( (cz<ostatni) || (cz >= ostatni &&  koniec == 'n' ))
	{
		for (nap=1 ; nap<=nr_napoju ; nap++)
		{dawka=0;
			if ((cz > napoje[nap]->godzina) && (napoje[nap]->spr=='n'))
			{
				porcja=napoje[nap]->ilosc/( napoje[nap]->czas_wchlaniania*\
						napoje[nap]->dlugosc_picia);

				if (napoje[nap]->czas_wchlaniania < napoje[nap]->dlugosc_picia)
				{
					if ( cz < napoje[nap]->godzina + napoje[nap]->czas_wchlaniania)
					{
						dawka=porcja*(cz-napoje[nap]->godzina);

					}
					else
					{
						if ( cz > napoje[nap]->godzina + napoje[nap]->dlugosc_picia)
						{
							dawka=(napoje[nap]->czas_wchlaniania+\
							napoje[nap]->godzina+napoje[nap]->dlugosc_picia-cz)*porcja;
						}
						else {dawka=napoje[nap]->czas_wchlaniania*porcja;}
					}
				}
				else // czas wchlaniania >= dlugosc picia
				{
					if ( cz < napoje[nap]->godzina + napoje[nap]->dlugosc_picia)
					{
						dawka=porcja*(cz-napoje[nap]->godzina);

					}
					else
					{
						if ( cz > napoje[nap]->godzina + napoje[nap]->czas_wchlaniania)
						{
							dawka=((napoje[nap]->czas_wchlaniania+\
							napoje[nap]->godzina+napoje[nap]->dlugosc_picia)-\
									cz)*porcja;
						}
						else {dawka=napoje[nap]->dlugosc_picia*porcja;}
					}

				}
				if (dawka<0) {dawka=0;}
				masa=masa+dawka*gestosc*napoje[nap]->stezenie/100.0;
				napoje[nap]->ile_wypite+=dawka;
				if (napoje[nap]->ile_wypite >= napoje[nap]->ilosc)
				{napoje[nap]->spr='t';}
			}

		}
		if (ui.radioButton_stala_szybkosc->isChecked())
		{
			masa=masa-(ile_na_godz/60.0);
		}
		else
		{	if (masa<5.8)
			{
			masa=masa-5.8/60;
			}
			else
			masa=masa-((ui.doubleSpinBox_maxg_na_godz->value()*masa) / (4.2+masa))/60.0;
		}
		if (masa<0){masa=0;}
		if ( ((int) (cz - pierwszy) %  co_ile == 0) || cz == pierwszy)
		{
	//		printf("\"%f\",\"%f\"\n",cz,masa/waga/wspolczynnik);
			wyswietl_wynik(masa/ilosc_plynow);
			ui.progressBar->setValue(int (cz/ostatni*100));
		}

		if (cz > ostatni && masa==0 && ((int) (cz - pierwszy) % co_ile==0)) {koniec='t';}
		cz++;
	}



	// oznaczanie jako niewypite
	for (nap=1 ; nap<=nr_napoju ; nap++)
	{
		napoje[nap]->spr='n';
		napoje[nap]->ile_wypite=0;
	}
	ui.progressBar->setValue(100);
return masa;
}

void Form1::dodaj_napoj(int ilosc, float godzina, float stezenie, float cz_wchl, int dl_pic)
{

		nr_napoju++;
		if (nr_napoju==1)
		{
			pierwszy=godzina; // ustawienie pierwszego napoju
		}
		else
		{
			if(godzina<pierwszy) {pierwszy=godzina;}
		}
		
		if (nr_napoju>=ILOSC_NAPOJOW)
		{
			ui.textBrowser_napoje->append("\n<font color=red><b>Osiagnieto limit napojow</b></font>");
			nr_napoju--;
			return;
		}

		napoje[nr_napoju] = new napoj(ilosc,stezenie,godzina,cz_wchl,dl_pic);

		ui.textBrowser_napoje->append("<b>Dodano " + QString::number(nr_napoju) + " napoj: </b>" + QString::number(ui.spinBox_ilosc->value()) +  " ml " + QString::number(ui.doubleSpinBox_zawartosc->value()) + " % dzien " + QString::number(ui.spinBox_czas_dzien->value()) +" godzina " + QString::number(ui.spinBox_czas_godz->value()) + ":" + QString::number(ui.spinBox_czas_min->value()));
		
		
			if ( godzina + dl_pic + cz_wchl > ostatni )
			{
				ostatni = godzina + cz_wchl + dl_pic; // godzina wchloniecia ostatniego napoju
			}
		
}


void kasuj_napoje(void)
{
	int nap;
	int ilosc_napoi;
	ilosc_napoi=nr_napoju;
	for (nap=1; nap<=ilosc_napoi;nap++)
	{
		napoje[nap]->~napoj();		
	}
}


void Form1::wyswietl_tytul_tabeli()
{
ui.textBrowser_wynik->insertHtml("<table border=\"0\" width=\"300\"><tr><td><b>Godzina</b></td><td><b>Stezenie we krwi [&permil;]</b></td></tr></table>");

}

void Form1::wyswietl_wynik(float wynik)
{		char * o1, * o2,* z1,* z2; //znaczniki otwierające i zamykające
		int godziny,minuty,dzien;
		char wyswietl[150];
		dzien = int (cz/(24*60.0));
		godziny = int (cz - 24*60*dzien)/60;
		minuty = int (cz - 24*60*dzien - godziny*60);
		dzien=dzien+1; //aby pierwszy dzien by 1 a nie 0		
		
		if (wyswietlono != dzien)
		{
			ui.textBrowser_wynik->append("\n");
			ui.textBrowser_wynik->insertHtml("<b>Dzien " + QString::number(dzien) + "</b>");
			wyswietlono=dzien;
		}	

		if ((wynik>=ui.doubleSpinBox_dop_stez->value() && wynik>0)) //wyświetl na czerwono jeśli poqyżęj dopuszczalnego stenia
		{
			o1="<table border=\"0\" width=\"300\"><tr><p><td><font color=red>";
			z1="</font></td>";
			o2="<td><font color=red>";
			z2="</font></td></p></tr><table>";
		}
		else
		if (wynik==0) // na zielono kiedy 0 promili
		{
			o1="<table border=\"0\" width=\"300\"><tr><p><td><font color=\"#00CC00\">";
			z1="</font></td>";
			o2="<td><font color=\"#00CC00\">";
			z2="</font></td></p></tr><table>";
		}
		else
		{
			o1="<table border=\"0\" width=\"300\"><tr><p><td><font color=\"#FF7700\">"; // na pomaraczowo kiedy 0<promile<dopuszczalne
			z1="</font></td>";
			o2="<td><font color=\"#FF7700\">";
			z2="</font></td></p></tr><table>";
		}

		if (wynik>=ui.doubleSpinBox_dawka_smiertelna->value())
		{
		sprintf(wyswietl, "%s%s%02i%s%02i%s%s%.3f%s%s" ,"<b>", o1,godziny ,":",minuty,z1,o2, wynik,z2,"</b>");
		}
		else
		{
		sprintf(wyswietl, "%s%02i%s%02i%s%s%.3f%s" , o1,godziny ,":",minuty,z1,o2, wynik,z2);
		}
		ui.textBrowser_wynik->insertHtml(wyswietl);
}


float Form1::tluszcz(float waga)
{
	float ilosc_tluszczu=0;
	float h2=(ui.spinBox_wzrost->value()/100.0)*(ui.spinBox_wzrost->value()/100.0);
	float bmi=waga/h2;
	if (bmi>25)
	{
		ilosc_tluszczu=(bmi-25)*h2;
	}
	if (bmi<18.5)
	{
		ilosc_tluszczu=(bmi-18.5)*h2;
	}
	return ilosc_tluszczu;
}

void Form1::bmi_info(float waga)
{
	float h2=(ui.spinBox_wzrost->value()/100.0)*(ui.spinBox_wzrost->value()/100.0);
	float bmi=(waga/h2);

	if (bmi>25)
	{
		ui.textBrowser_wynik->insertHtml("\nTwoj indeks masy ciala wynosi " + QString::number(bmi) + " i moze wskazywac na nadwage.\nDlatego program skorygowal zawartosc plynow ustrojowych.\nJesli nie masz nadwagi - zaznacz opcje \"nie uwzgledniaj wspolczynnika BMI\"");
	}

	if (bmi<18.5)
	{
		ui.textBrowser_wynik->insertHtml("\nTwoj indeks masy ciala wynosi "+ QString::number(bmi) + " i moze wskazywac na niedowage. \nDlatego program skorygowal zawartosc plynow ustrojowych.\nJesli nie masz niedowagi - zaznacz opcje \"nie uwzgledniaj wspolczynnika BMI\"");
	}

}

//////////////////////////////////////
//             M A I N              //
//////////////////////////////////////
void Form1::glowna (char plec, float masa, int co_ile_minut,float ing)
{
	wspolczynnik=spytaj_o_plec(plec);
	waga=masa;
	
	
	if (ui.checkBox_bmi->isChecked())
	{
		ilosc_plynow=waga*wspolczynnik;
	}
	else
	{
	ilosc_plynow=(waga-0.85*tluszcz(waga))*wspolczynnik; // 85% wody w tkance tuszczowej
	}

	ile_na_godz=ing*ilosc_plynow;
	co_ile=co_ile_minut;

	wyswietl_tytul_tabeli();	
	m_alk();
	if (!ui.checkBox_bmi->isChecked())
	{
	bmi_info(waga); //wywietl informacje o bmi
	}
	else
	{
		ui.textBrowser_wynik->insertHtml("Uwaga - program nie uwzglednil wspolczynnika BMI (Jesli mozliwe jest ze masz nadwage albo niedowage - odznacz opcje \"Nie uwzgledniaj wspolczynnika BMI\")");

	}
}
